Index: /palm/trunk/SOURCE/pres.f90
===================================================================
--- /palm/trunk/SOURCE/pres.f90	(revision 666)
+++ /palm/trunk/SOURCE/pres.f90	(revision 667)
@@ -4,5 +4,15 @@
 ! Current revisions:
 ! -----------------
-! 
+! New allocation of tend when ws-scheme and multigrid is used. This is due to 
+! reasons of perforance of the data_exchange. The same is done with p after
+! poismg is called.
+! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng when no 
+! multigrid is used. Calls of exchange_horiz are modified.
+!
+! bugfix: After pressure correction no volume flow correction in case of 
+! non-cyclic boundary conditions 
+! (has to be done only before pressure correction)
+!
+! Call of SOR routine is referenced with ddzu_pres.
 !
 ! Former revisions:
@@ -74,8 +84,20 @@
 
 !
-!-- Multigrid method needs additional grid points for the divergence array
+!-- Multigrid method expects 1 additional grid point for the arrays 
+!-- d, tend and p
     IF ( psolver == 'multigrid' )  THEN
+     
        DEALLOCATE( d )
-       ALLOCATE( d(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
+       ALLOCATE( d(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) ) 
+       
+       IF ( ws_scheme_mom  .OR. ws_scheme_sca )  THEN
+       
+          DEALLOCATE( tend )
+          ALLOCATE( tend(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
+          DEALLOCATE( p )
+          ALLOCATE( p(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
+          
+       ENDIF
+       
     ENDIF
 
@@ -103,5 +125,5 @@
 !--       Sum up the volume flow through the south/north boundary
           DO  k = nzb_2d(j,i) + 1, nzt
-             volume_flow_l(1) = volume_flow_l(1) + u(k,j,i) * dzu(k)
+             volume_flow_l(1) = volume_flow_l(1) + u(k,j,i) * dzw(k)
           ENDDO
        ENDDO
@@ -117,6 +139,6 @@
                                / volume_flow_area(1)
 
-       DO  j = nys-1, nyn+1
-          DO  k = nzb_v_inner(j,i) + 1, nzt
+       DO  j = nysg, nyng
+          DO  k = nzb_2d(j,i) + 1, nzt
              u(k,j,i) = u(k,j,i) + volume_flow_offset(1)
           ENDDO
@@ -142,5 +164,5 @@
 !--       Sum up the volume flow through the south/north boundary
           DO  k = nzb_2d(j,i) + 1, nzt
-             volume_flow_l(2) = volume_flow_l(2) + v(k,j,i) * dzu(k)
+             volume_flow_l(2) = volume_flow_l(2) + v(k,j,i) * dzw(k)
           ENDDO
        ENDDO
@@ -156,5 +178,5 @@
                                / volume_flow_area(2)
 
-       DO  i = nxl-1, nxr+1
+       DO  i = nxlg, nxrg
           DO  k = nzb_v_inner(j,i) + 1, nzt
              v(k,j,i) = v(k,j,i) + volume_flow_offset(2)
@@ -186,6 +208,6 @@
              w_l(k) = w_l(k) / ngp_2dh_outer(k,0)
           ENDDO
-          DO  i = nxl-1, nxr+1
-             DO  j = nys-1, nyn+1
+          DO  i = nxlg, nxrg
+             DO  j = nysg, nyng
                 DO  k = nzb_w_inner(j,i)+1, nzt
                    w(k,j,i) = w(k,j,i) - w_l(k)
@@ -267,7 +289,7 @@
           DO  j = nys, nyn
              DO  k = nzb_s_inner(j,i)+1, nzt
-                d(k,j,i) = ( ( u(k,j,i+1) - u(k,j,i) ) * ddx + &
-                             ( v(k,j+1,i) - v(k,j,i) ) * ddy + &
-                             ( w(k,j,i) - w(k-1,j,i) ) * ddzw(k) ) * ddt_3d
+             d(k,j,i) = ( ( u(k,j,i+1) - u(k,j,i) ) * ddx + &
+                          ( v(k,j+1,i) - v(k,j,i) ) * ddy + &
+                          ( w(k,j,i) - w(k-1,j,i) ) * ddzw(k) ) * ddt_3d
              ENDDO
           ENDDO
@@ -298,6 +320,6 @@
              DO  k = nzb_s_inner(j,i)+1, nzt
                 d(k,j,i) = ( ( u(k,j,i+1) - u(k,j,i) ) * ddx + &
-                             ( v(k,j+1,i) - v(k,j,i) ) * ddy + &
-                             ( w(k,j,i) - w(k-1,j,i) ) * ddzw(k) ) * ddt_3d
+                          ( v(k,j+1,i) - v(k,j,i) ) * ddy + &
+                          ( w(k,j,i) - w(k-1,j,i) ) * ddzw(k) ) * ddt_3d
              ENDDO
           ENDDO
@@ -331,5 +353,5 @@
 !-- comment line)
 !    CALL global_min_max( nzb+1, nzt, nys, nyn, nxl, nxr, d, 'abs', divmax, &
-!                         divmax_ijk )
+!                        divmax_ijk )
 
     CALL cpu_log( log_point_s(1), 'divergence', 'stop' )
@@ -364,5 +386,5 @@
        IF ( nxra > nxr  .OR.  nyna > nyn  .OR.  nza > nz )  THEN
           DEALLOCATE( tend )
-          ALLOCATE( tend(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
+          ALLOCATE( tend(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
        ENDIF
 
@@ -387,6 +409,6 @@
 !--       Neumann (dp/dz = 0)
           !$OMP PARALLEL DO
-          DO  i = nxl-1, nxr+1
-             DO  j = nys-1, nyn+1
+          DO  i = nxlg, nxrg
+             DO  j = nysg, nyng
                 tend(nzb_s_inner(j,i),j,i) = tend(nzb_s_inner(j,i)+1,j,i)
              ENDDO
@@ -400,6 +422,6 @@
 !--       the computation (cf. above: computation of divergences).
           !$OMP PARALLEL DO
-          DO  i = nxl-1, nxr+1
-             DO  j = nys-1, nyn+1
+          DO  i = nxlg, nxrg
+             DO  j = nysg, nyng
                 tend(nzb_s_inner(j,i),j,i) = tend(nzb_s_inner(j,i)+1,j,i)
              ENDDO
@@ -410,6 +432,6 @@
 !--       Dirichlet
           !$OMP PARALLEL DO
-          DO  i = nxl-1, nxr+1
-             DO  j = nys-1, nyn+1
+          DO  i = nxlg, nxrg
+             DO  j = nysg, nyng
                 tend(nzb_s_inner(j,i),j,i) = 0.0
              ENDDO
@@ -424,6 +446,6 @@
 !--       Neumann
           !$OMP PARALLEL DO
-          DO  i = nxl-1, nxr+1
-             DO  j = nys-1, nyn+1
+          DO  i = nxlg, nxrg
+             DO  j = nysg, nyng
                 tend(nzt+1,j,i) = tend(nzt,j,i)
              ENDDO
@@ -434,6 +456,6 @@
 !--       Dirichlet
           !$OMP PARALLEL DO
-          DO  i = nxl-1, nxr+1
-             DO  j = nys-1, nyn+1
+          DO  i = nxlg, nxrg
+             DO  j = nysg, nyng
                 tend(nzt+1,j,i) = 0.0
              ENDDO
@@ -444,5 +466,5 @@
 !
 !--    Exchange boundaries for p
-       CALL exchange_horiz( tend )
+       CALL exchange_horiz( tend, nbgp )
       
     ELSEIF ( psolver == 'sor' )  THEN
@@ -451,5 +473,5 @@
 !--    Solve Poisson equation for perturbation pressure using SOR-Red/Black
 !--    scheme
-       CALL sor( d, ddzu, ddzw, p )
+       CALL sor( d, ddzu_pres, ddzw, p )
        tend = p
 
@@ -458,11 +480,28 @@
 !
 !--    Solve Poisson equation for perturbation pressure using Multigrid scheme,
-!--    array tend is used to store the residuals
+!--    array tend is used to store the residuals, logical exchange_mg is used
+!--    to discern data exchange in multigrid ( 1 ghostpoint ) and normal grid
+!--    ( nbgp ghost points ).
+       exchange_mg = .TRUE.
        CALL poismg( tend )
- 
+       exchange_mg = .FALSE.
 !
 !--    Restore perturbation pressure on tend because this array is used
 !--    further below to correct the velocity fields
+
        tend = p
+       IF( ws_scheme_mom .OR. ws_scheme_sca )  THEN
+!       
+!--       Allocate p to its normal size and restore pressure.         
+          DEALLOCATE( p )
+          ALLOCATE( p(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+          DO  i = nxl, nxr
+             DO  j = nys, nyn
+                DO  k = nzb_s_inner(j,i), nzt
+                   p(k,j,i) = tend(k,j,i)
+                ENDDO
+             ENDDO
+          ENDDO
+       ENDIF
 
     ENDIF
@@ -476,8 +515,8 @@
 !--    optimization
        !$OMP PARALLEL DO
-       DO  j = nys-1, nyn+1
+       DO  j = nysg, nyng
           DO  k = nzb, nzt+1
-             p(k,j,nxl-1) = tend(k,j,nxl-1)
-             p(k,j,nxr+1) = tend(k,j,nxr+1)
+             p(k,j,nxlg:nxl-1) = tend(k,j,nxlg:nxl-1)
+             p(k,j,nxr+1:nxrg) = tend(k,j,nxr+1:nxrg)
           ENDDO
        ENDDO
@@ -496,5 +535,5 @@
     DO  i = nxl, nxr
        IF ( psolver(1:7) == 'poisfft' )  THEN
-          DO  j = nys-1, nyn+1
+          DO  j = nysg, nyng
              DO  k = nzb, nzt+1
                 p(k,j,i) = tend(k,j,i)
@@ -517,16 +556,16 @@
 !--       Sum up the volume flow through the right and north boundary
           IF ( conserve_volume_flow  .AND.  bc_lr == 'cyclic'  .AND. &
-               i == nx )  THEN
+               bc_ns == 'cyclic' .AND. i == nx )  THEN
              !$OMP CRITICAL
              DO  k = nzb_2d(j,i) + 1, nzt
-                volume_flow_l(1) = volume_flow_l(1) + u(k,j,i) * dzu(k)
+                volume_flow_l(1) = volume_flow_l(1) + u(k,j,i) * dzw(k)
              ENDDO
              !$OMP END CRITICAL
           ENDIF
           IF ( conserve_volume_flow  .AND.  bc_ns == 'cyclic'  .AND. &
-               j == ny )  THEN
+               bc_lr == 'cyclic' .AND. j == ny )  THEN
              !$OMP CRITICAL
              DO  k = nzb_2d(j,i) + 1, nzt
-                volume_flow_l(2) = volume_flow_l(2) + v(k,j,i) * dzu(k)
+                volume_flow_l(2) = volume_flow_l(2) + v(k,j,i) * dzw(k)
              ENDDO
              !$OMP END CRITICAL
@@ -538,7 +577,15 @@
 
 !
+!-- Resize tend to its normal size in case of multigrid and ws-scheme.
+    IF ( psolver == 'multigrid' .AND. ( ws_scheme_mom        &
+                                   .OR. ws_scheme_sca ) )  THEN
+       DEALLOCATE( tend )
+       ALLOCATE( tend(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+    ENDIF
+
+!
 !-- Conserve the volume flow
     IF ( conserve_volume_flow  .AND. &
-         ( bc_lr == 'cyclic'  .OR.  bc_ns == 'cyclic' ) )  THEN
+         ( bc_lr == 'cyclic'  .AND.  bc_ns == 'cyclic' ) )  THEN
 
 #if defined( __parallel )   
@@ -557,16 +604,11 @@
        DO  i = nxl, nxr
           DO  j = nys, nyn
-             IF ( bc_lr == 'cyclic' )  THEN
-                DO  k = nzb_u_inner(j,i) + 1, nzt
-                   u(k,j,i) = u(k,j,i) + volume_flow_offset(1)
-                ENDDO
-             ENDIF
-             IF ( bc_ns == 'cyclic' )  THEN
-                DO  k = nzb_v_inner(j,i) + 1, nzt
-                   v(k,j,i) = v(k,j,i) + volume_flow_offset(2)
-                ENDDO
-             ENDIF
-          ENDDO
-       ENDDO
+             DO  k = nzb_u_inner(j,i) + 1, nzt
+                u(k,j,i) = u(k,j,i) + volume_flow_offset(1)
+                v(k,j,i) = v(k,j,i) + volume_flow_offset(2)
+             ENDDO
+          ENDDO
+       ENDDO
+
        !$OMP END PARALLEL
 
@@ -575,7 +617,7 @@
 !
 !-- Exchange of boundaries for the velocities
-    CALL exchange_horiz( u )
-    CALL exchange_horiz( v )
-    CALL exchange_horiz( w )
+    CALL exchange_horiz( u, nbgp )
+    CALL exchange_horiz( v, nbgp )
+    CALL exchange_horiz( w, nbgp )
 
 !
@@ -620,4 +662,5 @@
     ENDDO
 #endif
+
     localsum = localsum + threadsum
     !$OMP END PARALLEL
@@ -631,4 +674,5 @@
 
     CALL cpu_log( log_point(8), 'pres', 'stop' )
+    
 
 
Index: /palm/trunk/SOURCE/production_e.f90
===================================================================
--- /palm/trunk/SOURCE/production_e.f90	(revision 666)
+++ /palm/trunk/SOURCE/production_e.f90	(revision 667)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng
 !
 ! Former revisions:
@@ -1109,6 +1109,6 @@
 
           IF ( first_call )  THEN
-             ALLOCATE( u_0(nys-1:nyn+1,nxl-1:nxr+1), &
-                       v_0(nys-1:nyn+1,nxl-1:nxr+1) )
+             ALLOCATE( u_0(nysg:nyng,nxlg:nxrg), &
+                       v_0(nysg:nyng,nxlg:nxrg) )
              first_call = .FALSE.
           ENDIF
Index: /palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- /palm/trunk/SOURCE/prognostic_equations.f90	(revision 666)
+++ /palm/trunk/SOURCE/prognostic_equations.f90	(revision 667)
@@ -4,5 +4,7 @@
 ! Current revisions:
 ! -----------------
-!
+! Calls of the advection routines with WS5 added.
+! Calls of ws_statistics added to set the statistical arrays to zero after each 
+! time step.
 !
 ! Former revisions:
@@ -79,5 +81,5 @@
     USE pointer_interfaces
     USE statistics
-
+    USE advec_ws
     USE advec_s_pw_mod
     USE advec_s_up_mod
@@ -144,4 +146,6 @@
     IF ( ocean    )  CALL calc_mean_profile( rho, 64 )
     IF ( humidity )  CALL calc_mean_profile( vpt, 44 )
+    IF ( ( ws_scheme_mom .OR. ws_scheme_sca ) .AND. &
+       intermediate_timestep_count == 1 )  CALL ws_statistics
 
 !
@@ -164,5 +168,10 @@
           IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' )  THEN
              tend(:,j,i) = 0.0
-             CALL advec_u_pw( i, j )
+             IF ( ws_scheme_mom )  THEN
+                 CALL advec_u_ws( i, j )
+             ELSE
+                 CALL advec_u_pw( i, j )
+             ENDIF
+
           ELSE
              IF ( momentum_advec /= 'ups-scheme' )  THEN
@@ -245,5 +254,10 @@
           IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' )  THEN
              tend(:,j,i) = 0.0
-             CALL advec_v_pw( i, j )
+             IF ( ws_scheme_mom )  THEN
+                 CALL advec_v_ws( i, j )
+             ELSE 
+                 CALL advec_v_pw( i, j )
+             ENDIF
+
           ELSE
              IF ( momentum_advec /= 'ups-scheme' )  THEN
@@ -325,5 +339,10 @@
           IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' )  THEN
              tend(:,j,i) = 0.0
-             CALL advec_w_pw( i, j )
+             IF ( ws_scheme_mom )  THEN
+                 CALL advec_w_ws( i, j )
+             ELSE  
+                 CALL advec_w_pw( i, j )
+             ENDIF
+
           ELSE
              IF ( momentum_advec /= 'ups-scheme' )  THEN
@@ -425,5 +444,10 @@
              IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' )  THEN
                 tend(:,j,i) = 0.0
-                CALL advec_s_pw( i, j, pt )
+                IF ( ws_scheme_sca )  THEN
+                   CALL advec_s_ws( i, j, pt, 'pt', flux_s_pt, &
+                                 diss_s_pt, flux_l_pt, diss_l_pt )
+                ELSE
+                    CALL advec_s_pw( i, j, pt )
+                ENDIF
              ELSE
                 IF ( scalar_advec /= 'ups-scheme' )  THEN
@@ -541,5 +565,11 @@
                 IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' ) THEN
                    tend(:,j,i) = 0.0
-                   CALL advec_s_pw( i, j, sa )
+                   IF ( ws_scheme_sca )  THEN
+                       CALL advec_s_ws( i, j, sa, 'sa', flux_s_sa,  &
+                                    diss_s_sa, flux_l_sa, diss_l_sa )
+                   ELSE
+                       CALL advec_s_pw( i, j, sa )
+                   ENDIF
+
                 ELSE
                    IF ( scalar_advec /= 'ups-scheme' )  THEN
@@ -634,5 +664,10 @@
                 IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' ) THEN
                    tend(:,j,i) = 0.0
-                   CALL advec_s_pw( i, j, q )
+                   IF ( ws_scheme_sca )  THEN
+                       CALL advec_s_ws( i, j, q, 'q', flux_s_q, &
+                                   diss_s_q, flux_l_q, diss_l_q )
+                   ELSE
+                       CALL advec_s_pw( i, j, q )
+                   ENDIF
                 ELSE
                    IF ( scalar_advec /= 'ups-scheme' )  THEN
@@ -661,5 +696,5 @@
 !--          Sink or source of scalar concentration due to canopy elements
              IF ( plant_canopy ) CALL plant_canopy_model( i, j, 5 )
-
+             
 !
 !--          If required compute influence of large-scale subsidence/ascent
@@ -769,5 +804,10 @@
                    THEN
                       tend(:,j,i) = 0.0
-                      CALL advec_s_pw( i, j, e )
+                      IF ( ws_scheme_sca )  THEN
+                          CALL advec_s_ws( i, j, e, 'e', flux_s_e, & 
+                                      diss_s_e, flux_l_e, diss_l_e )
+                      ELSE
+                          CALL advec_s_pw( i, j, e )
+                      ENDIF
                    ELSE
                       IF ( scalar_advec /= 'ups-scheme' )  THEN
@@ -884,4 +924,6 @@
     IF ( humidity )  CALL calc_mean_profile( vpt, 44 )
     IF ( .NOT. constant_diffusion )  CALL production_e_init
+    IF ( ( ws_scheme_mom .OR. ws_scheme_sca ) .AND. &
+       intermediate_timestep_count == 1 )  CALL ws_statistics
 
 
@@ -898,6 +940,11 @@
              tend(:,j,i) = 0.0
              IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' )  THEN
-                CALL advec_u_pw( i, j )
-             ELSE
+                IF ( ws_scheme_mom )  THEN
+    !               CALL local_diss( i, j, u)    ! dissipation control
+                   CALL advec_u_ws( i, j )
+                ELSE 
+                   CALL advec_u_pw( i, j )
+                ENDIF 
+            ELSE
                 CALL advec_u_up( i, j )
              ENDIF
@@ -962,5 +1009,10 @@
              tend(:,j,i) = 0.0
              IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' )  THEN
-                CALL advec_v_pw( i, j )
+                IF ( ws_scheme_mom )  THEN
+                 !   CALL local_diss( i, j, v)
+                    CALL advec_v_ws( i, j )
+                ELSE 
+                    CALL advec_v_pw( i, j )
+                ENDIF
              ELSE
                 CALL advec_v_up( i, j )
@@ -1022,5 +1074,10 @@
           tend(:,j,i) = 0.0
           IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' )  THEN
-             CALL advec_w_pw( i, j )
+             IF ( ws_scheme_mom )  THEN
+             !   CALL local_diss( i, j, w)
+                CALL advec_w_ws( i, j )
+             ELSE 
+                CALL advec_w_pw( i, j )
+             END IF
           ELSE
              CALL advec_w_up( i, j )
@@ -1081,5 +1138,11 @@
           tend(:,j,i) = 0.0
           IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' )  THEN
-             CALL advec_s_pw( i, j, pt )
+                IF ( ws_scheme_sca )  THEN
+       !            CALL local_diss( i, j, pt )
+                   CALL advec_s_ws( i, j, pt, 'pt', flux_s_pt, &
+                             diss_s_pt, flux_l_pt, diss_l_pt )
+                ELSE
+                   CALL advec_s_pw( i, j, pt )
+                ENDIF
           ELSE
              CALL advec_s_up( i, j, pt )
@@ -1119,4 +1182,5 @@
           ENDIF
 
+
           CALL user_actions( i, j, 'pt-tendency' )
 
@@ -1156,5 +1220,11 @@
              IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' ) &
              THEN
-                CALL advec_s_pw( i, j, sa )
+                IF ( ws_scheme_sca )  THEN
+            !        CALL local_diss( i, j, sa )
+                    CALL advec_s_ws( i, j, sa, 'sa', flux_s_sa,  &
+                                diss_s_sa, flux_l_sa, diss_l_sa  )
+                ELSE 
+                    CALL advec_s_pw( i, j, sa )
+                ENDIF
              ELSE
                 CALL advec_s_up( i, j, sa )
@@ -1208,5 +1278,11 @@
              IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' ) &
              THEN
-                CALL advec_s_pw( i, j, q )
+                IF ( ws_scheme_sca )  THEN
+          !         CALL local_diss( i, j, q )
+                   CALL advec_s_ws( i, j, q, 'q', flux_s_q, & 
+                                diss_s_q, flux_l_q, diss_l_q )
+                ELSE 
+                   CALL advec_s_pw( i, j, q )
+                ENDIF
              ELSE
                 CALL advec_s_up( i, j, q )
@@ -1232,10 +1308,8 @@
              IF ( plant_canopy ) CALL plant_canopy_model( i, j, 5 )
 
-
 !--          If required compute influence of large-scale subsidence/ascent
              IF ( large_scale_subsidence ) THEN
                 CALL subsidence ( i, j, tend, q, q_init )
              ENDIF
-
 
              CALL user_actions( i, j, 'q-tendency' )
@@ -1279,6 +1353,12 @@
              tend(:,j,i) = 0.0
              IF ( ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' )  &
-                  .AND.  .NOT. use_upstream_for_tke )  THEN
-                CALL advec_s_pw( i, j, e )
+                 .AND.  .NOT. use_upstream_for_tke )  THEN
+                 IF ( ws_scheme_sca )  THEN
+                 !    CALL local_diss( i, j, e )
+                     CALL advec_s_ws( i, j, e, 'e', flux_s_e, &
+                                diss_s_e, flux_l_e, diss_l_e  )
+                 ELSE
+                     CALL advec_s_pw( i, j, e )
+                 ENDIF
              ELSE
                 CALL advec_s_up( i, j, e )
@@ -1379,4 +1459,6 @@
     IF ( ocean    )  CALL calc_mean_profile( rho, 64 )
     IF ( humidity )  CALL calc_mean_profile( vpt, 44 )
+    IF ( ( ws_scheme_mom .OR. ws_scheme_sca ) .AND. &
+       intermediate_timestep_count == 1 )  CALL ws_statistics
 
 !
@@ -1395,5 +1477,9 @@
     IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' )  THEN
        tend = 0.0
-       CALL advec_u_pw
+       IF ( ws_scheme_mom )  THEN
+          CALL advec_u_ws
+       ELSE
+          CALL advec_u_pw
+       ENDIF
     ELSE
        IF ( momentum_advec /= 'ups-scheme' )  THEN
@@ -1484,5 +1570,9 @@
     IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' )  THEN
        tend = 0.0
-       CALL advec_v_pw
+       IF ( ws_scheme_mom )  THEN
+          CALL advec_v_ws
+       ELSE 
+          CALL advec_v_pw
+       END IF
     ELSE
        IF ( momentum_advec /= 'ups-scheme' )  THEN
@@ -1572,5 +1662,9 @@
     IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' )  THEN
        tend = 0.0
-       CALL advec_w_pw
+       IF ( ws_scheme_mom )  THEN
+          CALL advec_w_ws
+       ELSE
+          CALL advec_w_pw
+       ENDIF
     ELSE
        IF ( momentum_advec /= 'ups-scheme' )  THEN
@@ -1676,5 +1770,9 @@
        IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' )  THEN
           tend = 0.0
-          CALL advec_s_pw( pt )
+          IF ( ws_scheme_sca )  THEN
+             CALL advec_s_ws( pt, 'pt' )
+          ELSE
+             CALL advec_s_pw( pt )
+          ENDIF
        ELSE
           IF ( scalar_advec /= 'ups-scheme' )  THEN
@@ -1795,5 +1893,9 @@
           IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' )  THEN
              tend = 0.0
-             CALL advec_s_pw( sa )
+             IF ( ws_scheme_sca )  THEN
+                 CALL advec_s_ws( sa, 'sa' )
+             ELSE
+                 CALL advec_s_pw( sa )
+             ENDIF
           ELSE
              IF ( scalar_advec /= 'ups-scheme' )  THEN
@@ -1894,5 +1996,9 @@
           IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' )  THEN
              tend = 0.0
-             CALL advec_s_pw( q )
+             IF ( ws_scheme_sca )  THEN
+                CALL advec_s_ws( q, 'q' )
+             ELSE
+                CALL advec_s_pw( q )
+             ENDIF
           ELSE
              IF ( scalar_advec /= 'ups-scheme' )  THEN
@@ -1920,5 +2026,5 @@
 !--    Sink or source of scalar concentration due to canopy elements
        IF ( plant_canopy ) CALL plant_canopy_model( 5 )
-
+       
 !
 !--    If required compute influence of large-scale subsidence/ascent
@@ -2029,5 +2135,9 @@
              IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' )  THEN
                 tend = 0.0
-                CALL advec_s_pw( e )
+                IF ( ws_scheme_sca )  THEN
+                   CALL advec_s_ws( e, 'e' )
+                ELSE 
+                   CALL advec_s_pw( e )
+                ENDIF
              ELSE
                 IF ( scalar_advec /= 'ups-scheme' )  THEN
